/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __LOG
#define         __LOG

#include <glib.h>

#ifdef __LOG_ENABLE
#include "Thread.h"
#include "Liste_Equipement.h"
#include "Notification_Equipement.h"
#include "Com/Communication.h"
#include "Thread_Detect.h"
#include "Notification_Port.h"
#include "Semaphore.h"
#include "Nessus.h"
#include "Snmp.h"
#include "Info.h"
#include "Scan_Signature.h"
#include "Liste_Sous_Reseau.h"
#include "Notification_Equipement.h"
#include "Scan_Equipement.h"
#include "Ip_Dynamic.h"

struct struct_Cle_Privee {
	gint      Categorie;
	void     *Pointeur_Data;
	gint      Nb_Appel_Malloc;
	gint      Nb_Appel_Free;
	gint      Nb_Appel_Realloc;
	size_t    Taille_Allouer;
	size_t    Taille_Liberer;
};


GList    *GList_Log_Main;
struct struct_Cle_Privee *Donnee_Cle_Main;
pthread_key_t Cle_privee_thread;
pthread_once_t once_cle_privee;



enum enum_Categorie_Debug {
	CATEG_MAIN = 0,
	CATEG_THREAD_DETECT,
	CATEG_THREAD_SCAN,
	CATEG_THREAD_NOTIF_PORT,
	CATEG_THREAD_NOTIF_EQU,
	CATEG_BOUCLE_COMMUNIC,
	CATEG_RAFFRAICHIR_EQU,
	CATEG_NESSUS,
	CATEG_THREAD_SNMP_LISTE_ALL,
	CATEG_THREAD_SNMP_LISTE,
	CATEG_BOUCLE_SCAN,
	CATEG_INFO_AGENT,
	CATEG_PING_DETECT,
	CATEG_SCAN_PLAGE,
	CATEG_THREAD_ETAT_EQUIPEMENT,
	CATEG_THREAD_WAKEUP,
	CATEG_IP_DYNAMIC
};

struct Struct_Categorie {
	gint      Categorie;
	gchar    *Info;
};

GList    *Recupere_Glist_Categorie (struct struct_Cle_Privee *pCle);
void      Log_Equipement (struct Struct_Liste_Equipement *Equipement, gchar * Message);
void      create_cle_privee (void);
void Initialisation_Log (void);
#endif

void      Envoie_Log_Equipement (gpointer * Donnee);


#ifdef __LOG_ENABLE
#define LOG_THREAD(_Donnee_Cle,_Categorie,_Data,_glist,_ChaineGlist) 	G_STMT_START{			\
	_glist = NULL; 															\
	G_LIST_APPEND (_glist, _ChaineGlist);									\
	pthread_once(&once_cle_privee,create_cle_privee);						\
	MALLOC(_Donnee_Cle,sizeof(struct struct_Cle_Privee));					\
	_Donnee_Cle->Categorie = _Categorie;									\
	_Donnee_Cle->Pointeur_Data = _Data;										\
	pthread_setspecific(Cle_privee_thread,_Donnee_Cle);						\
}G_STMT_END
#else
#define LOG_THREAD(_Donnee_Cle,_Categorie,_Data,_glist,_ChaineGlist) 	G_STMT_START{}G_STMT_END
#endif


#endif
