/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifdef __LOG_ENABLE
#include <errno.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <dirent.h>  
#endif
#include "Quit.h"
#include "Info.h"
#include "Debug.h"
#include "Thread_Detect.h"
#include "Declaration_Constante.h"
#include "Com/Initialisation_Com.h"
#include "Liste_Equipement.h"
#include "Notification_Equipement.h"
#include "Notification_Port.h"
#include "Scan_Signature.h"
#include "Com/Communication.h"
#include "Scan_Port.h"
#include "Snmp.h"
#include "Nessus.h"
#include "Liste_Sous_Reseau.h"
#include "Notification_Equipement.h"
#include "Scan_Equipement.h"
#include "Ip_Dynamic.h"
#include "Snmp.h"
#include "Semaphore.h"
#include "Macro.h"

#ifdef __LOG_ENABLE
extern struct Struct_Categorie Liste_Categorie[];
#endif

#ifdef __LOG_ENABLE
void Ecriture_Fichier_Sans_Retour_Chariot(int fd,gchar *Log){
	gint Taille_Chaine;
	
	Taille_Chaine = strlen(Log);
	if (Taille_Chaine!=write(fd,Log,Taille_Chaine)){
		printf("ERROR : Create log  (write)\n");
		exit (-1);
	}
}

void Ecriture_Fichier(int fd,gchar *Log){
	Ecriture_Fichier_Sans_Retour_Chariot(fd,Log);
	if (write(fd,"\n",1)!=1){
		printf("ERROR : Create log  (write)\n");
		exit (-1);
	}
}

void Ecriture_Fichier_time(gint fd,gchar *CValeur,time_t64 Valeur){
gchar Ligne[50];

	sprintf(Ligne,"[%s] = %d",CValeur,Valeur);
	Ecriture_Fichier(fd,Ligne);
}

void Ecriture_Fichier_valeur(gint fd,gchar *CValeur,gint Valeur){
gchar Ligne[50];

	sprintf(Ligne,"[%s] = %d",CValeur,Valeur);
	Ecriture_Fichier(fd,Ligne);
}

void Ecriture_Fichier_boolean(gint fd,gchar *Cbool,gboolean Etat){
gchar Ligne[50];
	
	if (Etat){
		sprintf(Ligne,"[%s] = TRUE",Cbool);
		Ecriture_Fichier(fd,Ligne);
	}
	else {
		sprintf(Ligne,"[%s] = FALSE",Cbool);
		Ecriture_Fichier(fd,Ligne);
	}
}

void Ecriture_Fichier_Utilisation_mem(gint fd, struct struct_Cle_Privee *Donnee_Cle){
gchar Ligne[100];

	sprintf(Ligne,"NonLibéré(%d)   Malloc(%d)(%d)  Realloc(%d)  Free(%d)(%d)",Donnee_Cle->Taille_Allouer-Donnee_Cle->Taille_Liberer,Donnee_Cle->Nb_Appel_Malloc, Donnee_Cle->Taille_Allouer,Donnee_Cle->Nb_Appel_Realloc,Donnee_Cle->Nb_Appel_Free,Donnee_Cle->Taille_Liberer);
	Ecriture_Fichier(fd,Ligne);
}

void Enregistrement_Log(){
	struct Struct_Liste_Equipement *Equipement = NULL;
	DIR      *dir = NULL;
	gchar    *Log = NULL;
	gint      Nb_Equipement, i,j, Nb_Log,Taille_Chaine;
	
	
	dir = opendir (REPERTOIRE_LOG);
	if (dir == NULL) {
	
		if (mkdir (REPERTOIRE_LOG, 0766) != 0) {
			printf("ERROR : Save log  (mkdir)\n");
			exit (-1);
		}
		dir = opendir (REPERTOIRE_LOG);
		if (dir == NULL) {
			printf("ERROR : Save log  (opendir)\n");
			exit (-1);
		}
	}
	closedir (dir);
	
	fd_Fichier_Log = open(REPERTOIRE_LOG "/autoscan-network-daemon", O_WRONLY | O_CREAT | O_TRUNC, 0644);
	if (fd_Fichier_Log<0){
		printf("ERROR : Create log  (open)\n");
		exit (-1);
	}
	
	
	
	Ecriture_Fichier(fd_Fichier_Log,"************** MAIN **************");
	Nb_Log = g_list_length (GList_Log_Main);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Main, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	Ecriture_Fichier_Utilisation_mem(fd_Fichier_Log,Donnee_Cle_Main);
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Nouveau_Equipement",Valeur_Semaphore(&Semaphore_Nouveau_Equipement));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Thread_Scan",Valeur_Semaphore(&Semaphore_Thread_Scan));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Info",Valeur_Semaphore(&Semaphore_Info));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Equipement",Valeur_Semaphore(&Semaphore_Equipement));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Control_Usage_Socket",Valeur_Semaphore(&Semaphore_Control_Usage_Socket));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Debug",Valeur_Semaphore(&Semaphore_Debug));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Notification_Equipement",Valeur_Semaphore(&Semaphore_Notification_Equipement));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Notification_Port",Valeur_Semaphore(&Semaphore_Notification_Port));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Snmp",Valeur_Semaphore(&Semaphore_Snmp));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Communication",Valeur_Semaphore(&Semaphore_Communication));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_DNS",Valeur_Semaphore(&Semaphore_DNS));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Mem",Valeur_Semaphore(&Semaphore_Mem));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_WakeUp",Valeur_Semaphore(&Semaphore_WakeUp));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Ping_Equipement",Valeur_Semaphore(&Semaphore_Ping_Equipement));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Etat_Thread",Valeur_Semaphore(&Semaphore_Etat_Thread));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Thread",Valeur_Semaphore(&Semaphore_Thread));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Scan_Arp_Sous_Reseau",Valeur_Semaphore(&Semaphore_Scan_Arp_Sous_Reseau));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_Fonction_Externe",Valeur_Semaphore(&Semaphore_Fonction_Externe));
	Ecriture_Fichier_valeur(fd_Fichier_Log,"Semaphore_BackTrace",Valeur_Semaphore(&Semaphore_BackTrace));

	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Equipements **************");
	Nb_Equipement = g_list_length (GList_Equipement);
	for (i = 0; i < Nb_Equipement; i++) {
		Equipement = g_list_nth_data (GList_Equipement, i);
		Nb_Log = g_list_length (Equipement->GList_Log);
		for (j=0;j<Nb_Log;j++){
			Log = g_list_nth_data (Equipement->GList_Log, j);
			Ecriture_Fichier(fd_Fichier_Log,Log);
		}
	}
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Detect **************");
	Nb_Log = g_list_length (GList_Log_Thread_Detect);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Detect, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Notification Equipement **************");
	Nb_Log = g_list_length (GList_Log_Thread_Notification_Equipement);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Notification_Equipement, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Raffraichi Equipement **************");
	Nb_Log = g_list_length (GList_Log_Thread_Raffraichi_Equipement);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Raffraichi_Equipement, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Notification Port **************");
	Nb_Log = g_list_length (GList_Log_Thread_Notification_Port);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Notification_Port, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Communication **************");
	Nb_Log = g_list_length (GList_Log_Thread_Communication);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Communication, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
	
#ifdef         __NESSUS_ENABLE	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Nessus **************");
	Nb_Log = g_list_length (GList_Log_Thread_Nessus);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Nessus, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
#endif

#ifdef        __SNMP_ENABLE
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Thread Snmp Liste All **************");
	Nb_Log = g_list_length (GList_Log_Thread_Snmp_Liste_All);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Snmp_Liste_All, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Thread Snmp Liste **************");
	Nb_Log = g_list_length (GList_Log_Thread_Snmp_Liste);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Snmp_Liste, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
#endif
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Boucle Scan **************");
	Nb_Log = g_list_length (GList_Log_Boucle_Scan);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Boucle_Scan, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Info Agent **************");
	Nb_Log = g_list_length (GList_Log_Info_Agent);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Info_Agent, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Ping Detect **************");
	Nb_Log = g_list_length (GList_Log_Ping_Detect);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Ping_Detect, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Scanner plage **************");
	Nb_Log = g_list_length (GList_Log_Scanner_plage);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Scanner_plage, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Thread Etat Equipement **************");
	Nb_Log = g_list_length (GList_Log_Thread_Etat_Equipement);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Etat_Equipement, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	

	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** WakeUP **************");
	Nb_Log = g_list_length (GList_Log_Thread_Envoie_WakeUp);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Envoie_WakeUp, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	
	
	Ecriture_Fichier(fd_Fichier_Log,"\n\n************** Ip Dynamic **************");
	Nb_Log = g_list_length (GList_Log_Ip_Dynamic);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Ip_Dynamic, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}	
	close(fd_Fichier_Log);
	fd_Fichier_Log = 0;
}


void Enregistre_Structure(){
	struct Struct_Liste_Equipement *Equipement = NULL;
	struct Struct_Port *Port = NULL;
	DIR      *dir = NULL;
	gchar    *Log = NULL,Temp[200],*InfoPort = NULL;
	gint      Nb_Equipement, i,j, Nb_Log,Taille_Chaine,Nb_Objet_Liste;
	
	
	dir = opendir (REPERTOIRE_LOG);
	if (dir == NULL) {
	
		if (mkdir (REPERTOIRE_LOG, 0766) != 0) {
			printf("ERROR : Save log  (mkdir)\n");
			exit (-1);
		}
		dir = opendir (REPERTOIRE_LOG);
		if (dir == NULL) {
			printf("ERROR : Save log  (opendir)\n");
			exit (-1);
		}
	}
	closedir (dir);
	
	fd_Fichier_Log = open(REPERTOIRE_LOG "/autoscan-network-daemon-struct", O_WRONLY | O_CREAT | O_TRUNC, 0644);
	if (fd_Fichier_Log<0){
		printf("ERROR : Create log  (open)\n");
		exit (-1);
	}
	
	Nb_Equipement = g_list_length (GList_Equipement);
	for (i = 0; i < Nb_Equipement; i++) {
		Equipement = g_list_nth_data (GList_Equipement, i);
		
		Ecriture_Fichier(fd_Fichier_Log,"*******************************"); 
		sprintf (Temp,"ID_Equipement [%02X:%02X:%02X:%02X:%02X:%02X -- %d.%d.%d.%d]", Equipement->ID_Equipement[0], Equipement->ID_Equipement[1], Equipement->ID_Equipement[2], Equipement->ID_Equipement[3], Equipement->ID_Equipement[4], Equipement->ID_Equipement[5], Equipement->ID_Equipement[6], Equipement->ID_Equipement[7], Equipement->ID_Equipement[8], Equipement->ID_Equipement[9]);
		Ecriture_Fichier(fd_Fichier_Log,Temp);
		Ecriture_Fichier(fd_Fichier_Log,Equipement->Adresse_Ip_Char);
		Ecriture_Fichier(fd_Fichier_Log,Equipement->Adresse_MAC_Char);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Agent_AutoScan",Equipement->Agent_AutoScan);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Scan_Port_En_Cours",Equipement->Scan_Port_En_Cours);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Intrus",Equipement->Intrus);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Equipement_Restaurer",Equipement->Equipement_Restaurer);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Equipement_Rescanner_En_Cours",Equipement->Equipement_Rescanner_En_Cours);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Equipement_Allumer",Equipement->Equipement_Allumer);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Rafraichissement_Etat_En_Cours",Equipement->Rafraichissement_Etat_En_Cours);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Agent_AutoScan",Equipement->Agent_AutoScan);
		Ecriture_Fichier_time(fd_Fichier_Log,"Derniere_Modification_Etat_Equipement",Equipement->Derniere_Modification_Etat_Equipement);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Notification_Equipement",Equipement->Notification_Equipement);
		Ecriture_Fichier_valeur(fd_Fichier_Log,"Compteur_Notification",Equipement->Compteur_Notification);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Alerte_Equipement_Active",Equipement->Alerte_Equipement_Active);
		
		Ecriture_Fichier(fd_Fichier_Log,"**** Ports"); 
		Nb_Objet_Liste = g_list_length (GList_Port);
		for (j = 0; j < Nb_Objet_Liste; j++) {
			Port = g_list_nth_data (Equipement->GList_Port, j);
			if (Port->Etat_Port==OUVERT){
				InfoPort = g_strdup_printf("Num_Port(%d)  Notification(%d)  Compteur_Notification(%d)  Niveau_Notification(%d)  Etat_Port(%d)  Alerte_Port_Active(%d)", Port->Num_Port,Port->Notification,Port->Compteur_Notification,Port->Niveau_Notification,Port->Etat_Port,Port->Alerte_Port_Active);
				Ecriture_Fichier(fd_Fichier_Log,InfoPort);
				FREE(InfoPort);
			}
		}
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Scanne_Port_En_Cours",Equipement->Scanne_Port_En_Cours);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Scan_Signature",Equipement->Scan_Signature);
	
	
	
	
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Snmp_Ouvert",Equipement->Snmp_Ouvert);
	
		Ecriture_Fichier_boolean(fd_Fichier_Log,"GateWay",Equipement->GateWay);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Routage_Activer",Equipement->Routage_Activer);
		Ecriture_Fichier_valeur(fd_Fichier_Log,"Port_Source_Test_GateWay",Equipement->Port_Source_Test_GateWay);
		Ecriture_Fichier_valeur(fd_Fichier_Log,"Port_Destination_Test_GateWay",Equipement->Port_Destination_Test_GateWay);
		Ecriture_Fichier_boolean(fd_Fichier_Log,"Marquage_Change_Ip",Equipement->Marquage_Change_Ip);
	}
	close(fd_Fichier_Log);
	fd_Fichier_Log = 0;
}
#endif

void Arret_Immediat(){
	printf("Arret_Immediat : FAILED\n");
	if (fd_Fichier_Log!=0)
		close(fd_Fichier_Log);
	exit(-1);
}



void Exit(){
	if (client_id!=-1){
		printf("Close Socket\n");
		shutdown (client_id, 0);
  		close (client_id);
	}
#ifdef __LOG_ENABLE
	printf("Save Log\n");
	Enregistrement_Log();
	printf("Save Struct\n");
	Enregistre_Structure();
#endif
	printf ("Stopping %s (http://autoscan-network.com)\n", VERSION_AGENT);
	exit(EXIT_SUCCESS);	
}


void Arret_Demande (gpointer * Message)
{
	if(!pthread_equal( pthread_self(), mainThreadId )){
		pthread_kill(mainThreadId,SIGINT);
		printf("Stopping ...\n");
		sleep(1);  
	
	
	
		printf("__1\n");
		sleep(1); 
		printf("__2\n");
		sleep(1); 
		printf("__3\n");
		sleep(1); 
		Exit();
	}

	fd_Fichier_Log = 0;
	signal (SIGSEGV, Arret_Immediat);

	printf("******** Stopping Thread *************\n");
	envoie_Signal_All_Thread(SIGUSR1);
	while (Nb_Thead!=0)
		sleep(1);
	printf("***************************************\n");
	Exit();
}


/*void Arret_Demande_Mem_Failed (struct struct_Cle_Privee *pCle,gpointer * Message,gchar *Fonction,void *pointeur, void *appel)
{
	struct Struct_Liste_Equipement* Equipement = NULL;
	GList    *GList_Log = NULL;
	gchar	*log;
	
	debug_memoire_disable();	

	fd_Fichier_Log = 0;
	signal (SIGSEGV, Arret_Immediat);

	display_backtrace(NULL,NULL,0);

	if (pCle->Categorie==CATEG_THREAD_SCAN)
		Equipement = pCle->Pointeur_Data;
	printf ("Memory corruption (%s)\n", Liste_Categorie[pCle->Categorie].Info);
	GList_Log = Recupere_Glist_Categorie(pCle);
	G_LIST_APPEND (GList_Log, "---------- Memory corruption ----------");
	log = g_strdup_printf(Message,Fonction,pointeur,appel);
	G_LIST_APPEND (GList_Log, log);

	Vidage_Memoire();

	display_backtrace (GList_Log,NULL,0);

	pthread_kill(mainThreadId,SIGINT);
	printf("Stopping ()...\n");
	sleep(1);  



	printf("__1\n");
	sleep(1); 
	printf("__2\n");
	sleep(1); 
	printf("__3\n");
	sleep(1); 
	Exit();
}
*/
