/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdlib.h>
#include <signal.h>

#include "Declaration_Constante.h"
#include "Erreur.h"
#include "Quit.h"
#include "BackTrace.h"
#include "Debug.h"
#include "Semaphore.h"
#include "Com/Communication.h"
#include "Com/Commun.h"
#include "Com/Initialisation_Com.h"
#include "Scan_Port.h"
#include "Scan_Signature.h"
#include "Sous_Reseau_Autorise.h"
#include "Liste_Sous_Reseau.h"
#include "Liste_Equipement.h"
#include "Notification_Equipement.h"
#include "Notification_Port.h"
#include "Thread_Detect.h"
#include "Thread.h"
#include "Intrus.h"
#include "Info.h"
#include "Snmp.h"



void Instance_Agent(void){
	
	Demarrage_Complet_Agent = FALSE;
	GList_Liste_Thread = NULL;
	Id_Thread = 0;
	Nb_Thead = 0;
	client_id = -1;
	mainThreadId = pthread_self ();
	graine_rand_r= 0xabcdef;
	
	Nb_Socket_Ouverte = 0;
	client_id = -1; 
	Initialisation_Signal_Erreur ();
	
	Initialisation_Semaphore ();
	Initialisation_Debug ();
	Initialisation_Info ();
#ifdef        __SNMP_ENABLE
	Initialisation_Snmp();
#endif
	Initialisation_Liste_port ();
	Initialisation_Liste_Sous_Reseau_Autorise ();
	Initialisation_Liste_Sous_Reseau ();
	Initialisation_Liste_Equipement ();
	Initialisation_Notification_Equipement ();
	Initialisation_Notification_Port ();
#ifdef         __NESSUS_ENABLE
	Initialisation_Nessus_Variable();
#endif


	Initialise_Alerte_intrusion();
	Communication_Initialisation ();
	Envoie_Version_Agent ();
	while (1) {
		pause ();
	}
	exit(EXIT_SUCCESS);
}



int main (int argc, char *argv[])
{
#ifdef __BACKTRACE_ENABLE
	binary_name = g_strdup(argv[0]);
#endif
	printf("Starting %s (http://autoscan-network.com)\n", VERSION_AGENT);	
	
  	if (sizeof(int)    != 4) { printf("This platform's integers are not 32 bits.");exit(-1);}
  	if (sizeof(double) != 8) { printf("This platform's floats are not 64 bits.");exit(-1);}
  	if (sizeof(time_t) != 4) { printf("This platform's time_t is not 32 bits.");exit(-1);}
	  
	int pid,pid_Instance;
	
	pid=fork();
	if(pid<0)  {  
		printf("Fork : Error\n"); 
		exit(255); 
	}
	if (pid){		
		exit(EXIT_SUCCESS);
	}		
	
	while (1) {
      switch (fork()) {
       case -1:   
         printf("Fork : Error\n"); 
         exit(EXIT_FAILURE);
       case 0:   
         Instance_Agent();
         exit(EXIT_FAILURE);
       default:   
         wait(NULL);
	   	 sleep(3);
      }
      printf("Démarrage d'une nouvelle instance\n");
   } 
   exit(EXIT_SUCCESS);
	
}


/*
#include <pthread.h>
#include <errno.h>
#define NB_THREADS	200
gboolean kill_thread;
void *Thread_Test_Malloc (void * num)
{
	int * Bob = NULL, *Sauve_Bob = NULL;
	int i,Taille,j;
	
	i = num;
	Bob = num;
	printf("%ld: %p = %d    Bob : %p = %p\n",pthread_self(),&i,i,&Bob,Bob);
	sleep(5);
	while (!kill_thread){
	
	Taille = 4;
	Bob = malloc (sizeof(int)*Taille);
	Bob[0] = (int) num;
	Bob[1] = 65;
	Bob[2] = 66;
	Bob[3] = 67;
	Sauve_Bob = Bob;



	for (j=0;j<=10;j++){
		Taille = Taille *2;
		Bob = realloc(Bob,sizeof(int)*Taille);
		if (Bob==NULL){
			printf("%ld: Failed\n",pthread_self());
			pthread_exit(NULL);
		}
		if (Bob[0]!=num)
			printf("%ld: Failed Bob : %p=Anc[%p]  size struct : %d  Val : %d = %d\n",pthread_self(),Bob,Sauve_Bob,sizeof(int)*Taille,Bob[0],num);
	
	}

	free(Bob);
	}

	pthread_exit((void *) i);
}

void Test_malloc(){
	pthread_t thread[NB_THREADS];
	int       i;
	int       ret;
	void *retour;

	printf("Test malloc   Id Thread Parent : %ld\n",pthread_self());
	kill_thread = FALSE;
	
	for (i = 0; i < NB_THREADS; i ++){
		printf("i = %d\n",i);
		if (pthread_create (&thread[i],NULL, Thread_Test_Malloc,(void *) i)!= 0){ 
			printf("Malloc pthread_create Failed :%s : %d",__FILE__,__LINE__);
			exit(EXIT_FAILURE);	
		}		
	
	
	}

		
	printf("\n\nFin : Test malloc\n");
	sleep(25);
	printf("Free Test\n");
	free(test);
	printf("Fin\n");
	kill_thread = TRUE;

	for (i = 0; i < NB_THREADS; i ++){
		pthread_join(thread[i], NULL);
		if (retour != PTHREAD_CANCELED){
			printf("Code retour : %d\n",(int) retour);	
		}
	}
	sleep(2);
	Arret_Demande(NULL);
}
*/
