/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Log.h"
#include "Contribution.h"
#include "Debug.h"
#include "main.h"
#include "Declaration_Constante.h"
#include "Equipement_Port.h"
#include "Snmp.h"
#include "Com/Commun.h"
#include "Interface/Combo.h"
#include "Interface/Wizard_Interface_Add_FingerPrinting.h"
#include "Interface/Wizard_Callbacks_Add_FingerPrinting.h"
#include "Com/Initialisation_Com.h"

extern struct Struct_Liste_Port_UDP Liste_Port_UDP[];


gboolean Transfert_html (gchar * uri)
{
	GnomeVFSHandle *handle = NULL;
	GnomeVFSResult result;
	gchar     buffer[BUF_SIZE];
	GnomeVFSFileSize bytes_read;

	ERROR_if (uri == NULL);
	result = gnome_vfs_open (&handle, uri, GNOME_VFS_OPEN_READ);

	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "result : %d   Ok=%d", result, GNOME_VFS_OK);
	if (result != GNOME_VFS_OK) {
		debug_printf (INTERFACE, D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Unable to open URI, aborting\n");
		gnome_vfs_close (handle);
		return FALSE;
	}
	while (result == GNOME_VFS_OK) {
		result = gnome_vfs_read (handle, buffer, BUF_SIZE, &bytes_read);
		buffer[bytes_read] = 0;
		debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "(%d )%s", (int) bytes_read, buffer);
	}
	gnome_vfs_close (handle);
	return TRUE;
}


void contribution (struct Struct_Equipement *Equipement_Contrib,gchar * Nom, gchar * Type)
{
#define PORT_RECUP 15

	struct Struct_Port *Port_Equipement= NULL;
	char     *DebugSignature;
	gchar    *dLog_Equipement = NULL,*Contrib = NULL,  *PortUdpListe = NULL,*PortOuvertListe = NULL, *PortFermerListe = NULL,*PortFirewalledListe = NULL,*dEnteteFTP, *dEnteteHTTP, *dEnteteSMTP,*dEnteteIMAP, *dEnteteTELNET, *dArch, *Adresse_MAC_Fournisseur,*Info_Description_Snmp,*Info_System_Snmp,*Texte_Snmp_System_Device=NULL;
	GList    *Glist_Snmp = NULL;
	struct struct_Liste_Snmp *Info_Snmp = NULL;
	gint      i,j, Nb_Objet_Liste, Port[PORT_RECUP],Nb_Info_Snmp;

	ERROR_if (Equipement_Contrib == NULL);
	ERROR_if (Nom == NULL);
	ERROR_if (Type == NULL);


	
	dEnteteFTP = url_encode (Equipement_Contrib->Entete_FTP);
	dEnteteHTTP = url_encode (Equipement_Contrib->Entete_HTTP);
	dEnteteIMAP = url_encode (Equipement_Contrib->Entete_IMAP);
	dEnteteSMTP = url_encode (Equipement_Contrib->Entete_SMTP);
	dEnteteTELNET = url_encode (Equipement_Contrib->Entete_TELNET);
	DebugSignature = url_encode (Equipement_Contrib->Debug_Signature);
	dArch = url_encode (Info_Arch);

	if (strlen(Equipement_Contrib->Snmp.System_Name)!=0)
		Info_System_Snmp = url_encode (Equipement_Contrib->Snmp.System_Name);
	else
		Info_System_Snmp = url_encode (NULL);


	if (strlen(Equipement_Contrib->Snmp.Description)!=0)
		Info_Description_Snmp = url_encode (Equipement_Contrib->Snmp.Description);
	else
		Info_Description_Snmp = url_encode (NULL);
	


	Glist_Snmp= Equipement_Contrib->Glist_Snmp[SNMP_SYSTEM_DEVICE];
	Nb_Info_Snmp = g_list_length (Glist_Snmp);
	if (Nb_Info_Snmp>0){
	
		i = 0;
		Texte_Snmp_System_Device = NULL;
		while ((Nb_Info_Snmp > i) && (Texte_Snmp_System_Device == NULL)) {
			Info_Snmp = g_list_nth_data (Glist_Snmp, i);
		
			if ((Info_Snmp->Ligne==0) && (Info_Snmp->Colonne == 3)) {
				Texte_Snmp_System_Device = Info_Snmp->Info;  
			}
			i++;
		}
	
	}
	if (Texte_Snmp_System_Device == NULL)
		Texte_Snmp_System_Device = "--null--";


	Adresse_MAC_Fournisseur = g_strdup_printf ("%s[%s]", Equipement_Contrib->Adresse_MAC_Char, Recherche_Fournisseur_Equipement (Equipement_Contrib->Adresse_MAC_Char));


	bzero (Port, sizeof (gint) * PORT_RECUP);
	Nb_Objet_Liste = g_list_length (Equipement_Contrib->GList_Port);
	i = 0;
	while ((i < Nb_Objet_Liste) && (i < PORT_RECUP)) {
		Port_Equipement = g_list_nth_data (Equipement_Contrib->GList_Port, i);
		Port[i] = Port_Equipement->Num_Port;
		i++;
	}
	PortOuvertListe = g_strdup_printf ("[%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d]",Port[0], Port[1], Port[2], Port[3], Port[4],	Port[5], Port[6], Port[7], Port[8], Port[9],Port[10], Port[11], Port[12], Port[13], Port[14]	);


	bzero (Port, sizeof (gint) * PORT_RECUP);
	Nb_Objet_Liste = g_list_length (Equipement_Contrib->GList_Port_Fermer);
	i = 0;
	while ((i < Nb_Objet_Liste) && (i < PORT_RECUP)) {
		Port_Equipement = g_list_nth_data (Equipement_Contrib->GList_Port_Fermer, i);
		Port[i] = Port_Equipement->Num_Port;
		i++;
	}
	PortFermerListe = g_strdup_printf ("[%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d]",Port[0], Port[1], Port[2], Port[3], Port[4],	Port[5], Port[6], Port[7], Port[8], Port[9],Port[10], Port[11], Port[12], Port[13], Port[14]	);


	bzero (Port, sizeof (gint) * PORT_RECUP);
	Nb_Objet_Liste = g_list_length (Equipement_Contrib->GList_Port_Firewall);
	i = 0;
	while ((i < Nb_Objet_Liste) && (i < PORT_RECUP)) {
		Port_Equipement = g_list_nth_data (Equipement_Contrib->GList_Port_Firewall, i);
		Port[i] = Port_Equipement->Num_Port;
		i++;
	}
	PortFirewalledListe = g_strdup_printf ("[%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d]",Port[0], Port[1], Port[2], Port[3], Port[4],	Port[5], Port[6], Port[7], Port[8], Port[9],Port[10], Port[11], Port[12], Port[13], Port[14]	);
	

	bzero (Port, sizeof (gint) * PORT_RECUP);
	i = 0;
	j = 0;
	while ((i < NB_PORT_UDP) && (i < PORT_RECUP)) {
		if (Equipement_Contrib->Liste_Etat_Udp[i]==UNKOWN_UDP){
			Port[j] = Liste_Port_UDP[i].Num_Port_UDP;
			j++;
		}
		i++;
	}
	PortUdpListe = g_strdup_printf ("[%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d]",Port[0], Port[1], Port[2], Port[3], Port[4],	Port[5], Port[6], Port[7], Port[8], Port[9],Port[10], Port[11], Port[12], Port[13], Port[14]	);

	
#ifdef __LOG_ENABLE	

	Etat_Contribution = CONTRIBUTION_DONNEE_OK;

	while (Log_Equipement==NULL)
		sleep (1);

	dLog_Equipement = url_encode (Log_Equipement);
#else
	Etat_Contribution = CONTRIBUTION_DONNEE_OK;
	dLog_Equipement = g_strdup ("NoLog");
#endif

	Contrib = g_strdup_printf ("http://autoscan-network.com/Add_Contributing_V12.php?Version=" VERSION_AUTOSCAN 
	"&System_Name=%s&MD5_signature=%s&MD5_signature_W=%s&Type=%s&SCAN_Complet=%d&SCAN_Dns=%d&SCAN_Port=%d&SCAN_Signature=%d&SCAN_Samba=%d&Scan_Snmp=%d&NB_PORT_OUVERT=%d&PORT_LISTE_OUVERT=%s&NB_PORT_FERMER=%d&PORT_LISTE_FERMER=%s&NB_PORT_FIREWALLED=%d&PORT_LISTE_FIREWALLED=%s&PORT_LISTE_UDP=%s&ETAT_SNMP=%d&ADRESSE_MAC=%s&INFO_SYSTEM_SNMP=%s&INFO_DESCRIPTION_SNMP=%s&INFO_DESCRIPTION_SNMP_DEVICE=%s&PORT_FTP=%d&PORT_HTTP=%d&PORT_HTTPS=%d&PORT_IMAP=%d&PORT_SMTP=%d&PORT_TELNET=%d&PORT_SPOOLER=%d&PORT_SIP=%d&GATEWAY=%d&ROUTAGE=%d&ENTETE_FTP=[%s]&ENTETE_HTTP=[%s]&ENTETE_IMAP=[%s]&ENTETE_SMTP=[%s]&ENTETE_TELNET=[%s]&TEMP_FTP=%d&TEMP_HTTP=%d&TEMP_IMAP=%d&TEMP_SMTP=%d&TEMP_TELNET=%d&DEBUG_SIGNATURE=%s&ARCH=%s&LOG=%s", 
	Nom, 
	Equipement_Contrib->Md5_Signature, 
	Equipement_Contrib->Md5_Signature_W, 
	Type, 
	Equipement_Contrib->Temps_Scan_Complet,
	Equipement_Contrib->Temps_Resolv_DNS,
	Equipement_Contrib->Temps_Scan_Port,
	Equipement_Contrib->Temps_Scan_Signature,
	Equipement_Contrib->Temps_Samba,
	Equipement_Contrib->Temps_Scan_Snmp,
	
	
	Equipement_Contrib->Nb_Port_Ouvert, 
	PortOuvertListe, 
	Equipement_Contrib->Nb_Port_Fermer, 
	PortFermerListe,
	Equipement_Contrib->Nb_Port_Firewaller, 
	PortFirewalledListe,
	PortUdpListe,
	Equipement_Contrib->Snmp_Ouvert,
	Adresse_MAC_Fournisseur, 
	Info_System_Snmp,
	Info_Description_Snmp,
	Texte_Snmp_System_Device, 
	Cherche_Si_Port_Ouvert (Equipement_Contrib, PORT_FTP),
	Cherche_Si_Port_Ouvert (Equipement_Contrib, PORT_HTTP), 
	Cherche_Si_Port_Ouvert (Equipement_Contrib, PORT_HTTPS), 
	Cherche_Si_Port_Ouvert (Equipement_Contrib, PORT_IMAP), 
	Cherche_Si_Port_Ouvert (Equipement_Contrib, PORT_SMTP), 
	Cherche_Si_Port_Ouvert (Equipement_Contrib, PORT_TELNET), 
	Cherche_Si_Port_Ouvert (Equipement_Contrib, PORT_SPOOLER),
	Cherche_Si_Port_Ouvert (Equipement_Contrib, PORT_SIP),
	Equipement_Contrib->GateWay, 
	Equipement_Contrib->Routage,
	dEnteteFTP, 
	dEnteteHTTP, 
	dEnteteIMAP, 
	dEnteteSMTP, 
	dEnteteTELNET, 
	Equipement_Contrib->Temps_Scan_Service_Ftp,
	Equipement_Contrib->Temps_Scan_Service_Http,
	Equipement_Contrib->Temps_Scan_Service_Imap,
	Equipement_Contrib->Temps_Scan_Service_Smtp,
	Equipement_Contrib->Temps_Scan_Service_Telnet,
	DebugSignature, 
	dArch,
	dLog_Equipement);
	

	for (i = 0; i < strlen (Contrib); i++) {
		if ((Contrib[i] == ' ') || (Contrib[i] == ' &'))
			Contrib[i] = '_';
	}
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Web : (%s)", Contrib);
	if (!Transfert_html (Contrib))
		debug_printf (INTERFACE, D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Error send\n");
	g_free (dEnteteFTP);
	g_free (dEnteteHTTP);
	g_free (dEnteteIMAP);
	g_free (dEnteteTELNET);
	g_free (dArch);
	g_free (Contrib);
	g_free (Adresse_MAC_Fournisseur);
	g_free (PortOuvertListe);
	g_free (PortFermerListe);	
	g_free (PortFirewalledListe);
	g_free (PortUdpListe);
	g_free (Info_System_Snmp);
	g_free (Info_Description_Snmp);
	g_free (dLog_Equipement);
	free (DebugSignature);
}



gpointer Thread_Contribution_Fingerprinting (void)
{
#ifdef __LOG_ENABLE
	struct struct_Cle_Privee *Donnee_Cle;	
#endif
	
#ifdef __LOG_ENABLE

  	pthread_once(&once_cle_privee,create_cle_privee);
	Donnee_Cle = (struct struct_Cle_Privee*) malloc (sizeof(struct struct_Cle_Privee));
	bzero (Donnee_Cle, sizeof (struct struct_Cle_Privee));
	Donnee_Cle->Categorie = CATEG_THREAD_CONTRIBUTION;
	Donnee_Cle->Pointeur_Data = NULL;
	pthread_setspecific(Cle_privee_thread,Donnee_Cle);
#endif
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Thread_Contribution_Fingerprinting");
	contribution (Equipement_Selectionner,New_System_Name,New_System_Type_Char);
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Fin Thread Contribution");
	Stop_Thread (0);
}




void contribution_Erreur (gchar * Message_Erreur)
{
	gchar    *Contrib = NULL, *Message_URL = NULL, *Message = NULL, *dArch;
	int       i;

	ERROR_if (Message_Erreur == NULL);
	if (Info_Message_Critique==NULL)
		Message = Message_Erreur;
	else
		Message = g_strdup_printf ("\n\n%s\n\n%s",Message_Erreur,Info_Message_Critique);
	
	Message_URL = url_encode (Message);
	dArch = url_encode (Info_Arch);
	Contrib = g_strdup_printf ("http://autoscan-network.com/ErreurV3.php?Version=" VERSION_AUTOSCAN "&Message_Erreur=%s&ARCH=%s", Message_URL, dArch);
	g_free (Message_URL);

	for (i = 0; i < strlen (Contrib); i++) {
		if (Contrib[i] == ' ')
			Contrib[i] = '_';
	}
	if (!Transfert_html (Contrib))
		debug_printf (INTERFACE, D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Error send\n");
	g_free (Contrib);
	g_free (dArch);
}



void Recuperation_Log_Equipement(gpointer * Donnee){
#ifdef __LOG_ENABLE
	struct struct_Retour_Log_Equipement *Message = (struct struct_Retour_Log_Equipement *) Donnee;
	
	ERROR_if (Donnee == NULL);
	ERROR_if (Message->Info == NULL);
	Log_Equipement = g_strdup(Message->Info);
#endif
}
