/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <stdlib.h>
#include "Log.h"
#include "Debug.h"
#include "Animation.h"
#include "Update.h"
#include "Sound.h"
#include "Smtp.h"
#include "Contribution.h"
#include "BackTrace.h"


#ifdef __LOG_ENABLE

struct Struct_Categorie Liste_Categorie[] = {
	{CATEG_MAIN, "CATEG_MAIN"},
	{CATEG_THREAD_CONTRIBUTION, "CATEG_THREAD_CONTRIBUTION"},
	{CATEG_THREAD_SOUND, "CATEG_THREAD_SOUND"},
	{CATEG_THREAD_TEST_VERSION, "CATEG_THREAD_TEST_VERSION"},
	{CATEG_THREAD_ENVOIE_EMAIL, "CATEG_THREAD_ENVOIE_EMAIL"},
	{CATEG_THREAD_UPDATE_FINGERPRINTING, "CATEG_THREAD_UPDATE_FINGERPRINTING"}
};

GList    *Recupere_Glist_Categorie (struct struct_Cle_Privee *pCle)
{
	struct Struct_Liste_Equipement* Equipement = NULL;
	GList    *GList_Log = NULL;

	GList_Log = NULL;
	switch (pCle->Categorie) {
	    case CATEG_THREAD_CONTRIBUTION :
			GList_Log = GList_Log_Thread_Contribution;
			break;
		case CATEG_THREAD_SOUND :
#ifdef  __SOUND_ENABLE
			GList_Log = GList_Log_Thread_Sound;
#endif
			break;
		case CATEG_THREAD_TEST_VERSION :
			GList_Log = GList_Log_Thread_Test_Version;
			break;
		case CATEG_THREAD_ENVOIE_EMAIL:
			GList_Log = GList_Log_Thread_Envoie_Email;
			break;
		case CATEG_THREAD_UPDATE_FINGERPRINTING:
		
			break;
		default :
			pCle = Donnee_Cle_Main;
			GList_Log = GList_Log_Main;
	}	

	return GList_Log;
}


void create_cle_privee (void)
{
	if (pthread_key_create (&Cle_privee_thread, NULL) == -1)
		debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "pthread_key_create");
}


void Initialisation_Log (void)
{
	init_backtrace();
	once_cle_privee=PTHREAD_ONCE_INIT;
	GList_Log_Main = NULL;
	GList_Log_Main = g_list_append (GList_Log_Main, "---------------------------------------");
	GList_Log_Main = g_list_append (GList_Log_Main, "-------- LOG autoscan-network ---------");
	GList_Log_Main = g_list_append (GList_Log_Main, "----------------- MAIN ----------------");
	GList_Log_Main = g_list_append (GList_Log_Main, "---------------------------------------");
	Donnee_Cle_Main = (struct struct_Cle_Privee*) malloc (sizeof(struct struct_Cle_Privee));// sert à rester compatible avec le reste du code de debugage
	bzero (Donnee_Cle_Main, sizeof (struct struct_Cle_Privee));
	Donnee_Cle_Main->Categorie = CATEG_MAIN;// sert à rester compatible avec le reste du code de debugage
	Donnee_Cle_Main->Pointeur_Data = NULL;
	GList_Log_Thread_Test_Version = NULL; 
	GList_Log_Thread_Test_Version = g_list_append (GList_Log_Thread_Test_Version, "---------- Test Version ----------");
#ifdef  __SOUND_ENABLE
	GList_Log_Thread_Sound = NULL; 
	GList_Log_Thread_Sound = g_list_append (GList_Log_Thread_Sound, "---------- Thread Sound ----------");
#endif
	GList_Log_Thread_Envoie_Email = NULL; 
	GList_Log_Thread_Envoie_Email = g_list_append (GList_Log_Thread_Envoie_Email, "---------- Envoie Email ----------");

	GList_Log_Thread_Contribution = NULL; 
	GList_Log_Thread_Contribution = g_list_append (GList_Log_Thread_Contribution, "---------- Thread Contrib ----------");
}

#endif  
