/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Objet_Gestion_Texte.h"
#include "Objet.h"
#include "Equipement.h"
#include "Settings_Signature.h"
#include "Fournisseur.h"
#include "Debug.h"
#include "Equipement_Port.h"

extern struct Struct_Liste_Port_UDP Liste_Port_UDP[];

gchar    *Gestion_Texte_Default (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Texte = NULL;

	ERROR_if (pointer == NULL);
	Texte = (gchar *) Objet->Pointeur_Attacher;

	if (Texte == NULL)
		Texte = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Texte);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Texte) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Integer_Default (gpointer * pointer)
{

	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, (gint) Objet->Pointeur_Attacher);
	return Nouveau_Texte;
}

gchar    *Gestion_Pointeur_Texte_Default (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Texte = NULL;

	ERROR_if (pointer == NULL);
	Texte = *Objet->Pointeur_Attacher;

	if (Texte == NULL)
		Texte = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Texte);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Texte) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}

/*gchar    *Gestion_Texte_IP_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Adresse_Ip_Char);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Equipement->Adresse_Ip_Char) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Mac_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Adresse_MAC_Char);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Equipement->Adresse_MAC_Char) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}*/


gchar    *Gestion_Texte_Fournisseur_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Fournisseur = NULL;

	ERROR_if (pointer == NULL);
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Fournisseur_Equipement Fabricant");
	Fournisseur = Recherche_Fournisseur_Equipement (Equipement->Adresse_MAC_Char);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Fournisseur);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Fournisseur) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Syteme_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *System = NULL;

	ERROR_if (pointer == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Recherche system");
	if (Equipement->Signature != NULL)
		System = Equipement->Signature->System_Name;
	if (System == NULL) {
		if (Equipement->Agent_AutoScan)
			System = "Agent AutoScan";
		else if (Equipement->Nb_Port_Ouvert != 0)
			System = "Unknow equipment";
		else
			System = "Failed (No TCP ports found open on this machine)";
	}
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, System);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (System) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_SytemeMD5_W_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Md5_Signature_W);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_SytemeMD5_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Md5_Signature);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Syteme_Group_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *System_Group = NULL;
	struct Struct_Signature *Signature_Pere = NULL;

	ERROR_if (pointer == NULL);
	System_Group = "none";
	if (Equipement->Signature != NULL) {
		Signature_Pere = (struct Struct_Signature *) Equipement->Signature->Signature_Pere;
		if (Signature_Pere != NULL)
			System_Group = Signature_Pere->System_Name;
	}
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, System_Group);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Port_Info_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Nb_Port_Ouvert, Equipement->Nb_Port_Total_Scanner, Equipement->Nb_Port_Firewaller, Equipement->Nb_Port_Total_Scanner);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Port_Ouvert_Info_Equipement (gpointer * pointer)
{
	#define PORT_OUVERT_RECUP 15
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;	
	struct Struct_Port *Port_Equipement=NULL;
	gchar    *Nouveau_Texte = NULL,*PortOuvertListe = NULL;
	gint      i, Nb_Objet_Liste, PortOuvert[PORT_OUVERT_RECUP];
	
	ERROR_if (pointer == NULL);

	bzero (PortOuvert, sizeof (gint) * PORT_OUVERT_RECUP);
	Nb_Objet_Liste = g_list_length (Equipement->GList_Port);
	i = 0;
	while ((i < Nb_Objet_Liste) && (i < PORT_OUVERT_RECUP)) {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port, i);
		PortOuvert[i] = Port_Equipement->Num_Port;
		i++;
	}
	PortOuvertListe = g_strdup_printf ("[%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-...]",PortOuvert[0], PortOuvert[1], PortOuvert[2], PortOuvert[3], PortOuvert[4],	PortOuvert[5], PortOuvert[6], PortOuvert[7], PortOuvert[8], PortOuvert[9],PortOuvert[10], PortOuvert[11], PortOuvert[12], PortOuvert[13], PortOuvert[14]	);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, PortOuvertListe);
	g_free (PortOuvertListe);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Port_Fermer_Info_Equipement (gpointer * pointer)
{
	#define PORT_FERMER_RECUP 15
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;	
	struct Struct_Port_Fermer_Firewall *Port_Equipement=NULL;
	gchar    *Nouveau_Texte = NULL,*PortFermerListe = NULL;
	gint      i, Nb_Objet_Liste, PortFermer[PORT_FERMER_RECUP];
	
	ERROR_if (pointer == NULL);

	bzero (PortFermer, sizeof (gint) * PORT_FERMER_RECUP);
	Nb_Objet_Liste = g_list_length (Equipement->GList_Port_Fermer);
	i = 0;
	while ((i < Nb_Objet_Liste) && (i < PORT_FERMER_RECUP)) {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port_Fermer, i);
		PortFermer[i] = Port_Equipement->Num_Port;
		i++;
	}
	PortFermerListe = g_strdup_printf ("[%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-...]",PortFermer[0], PortFermer[1], PortFermer[2], PortFermer[3], PortFermer[4],	PortFermer[5], PortFermer[6], PortFermer[7], PortFermer[8], PortFermer[9],	PortFermer[10], PortFermer[11], PortFermer[12], PortFermer[13], PortFermer[14]	);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, PortFermerListe);
	g_free (PortFermerListe);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Port_Firewall_Info_Equipement (gpointer * pointer)
{
	#define PORT_FIREWALL_RECUP 15
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;	
	struct Struct_Port_Fermer_Firewall *Port_Equipement=NULL;
	gchar    *Nouveau_Texte = NULL,*PortFirewallListe = NULL;
	gint      i, Nb_Objet_Liste, PortFirewall[PORT_FIREWALL_RECUP];
	
	ERROR_if (pointer == NULL);

	bzero (PortFirewall, sizeof (gint) * PORT_FIREWALL_RECUP);
	Nb_Objet_Liste = g_list_length (Equipement->GList_Port_Firewall);
	i = 0;
	while ((i < Nb_Objet_Liste) && (i < PORT_FIREWALL_RECUP)) {
		Port_Equipement = g_list_nth_data (Equipement->GList_Port_Firewall, i);
		PortFirewall[i] = Port_Equipement->Num_Port;
		i++;
	}
	PortFirewallListe = g_strdup_printf ("[%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-%d-...]",PortFirewall[0], PortFirewall[1], PortFirewall[2], PortFirewall[3], PortFirewall[4],	PortFirewall[5], PortFirewall[6], PortFirewall[7],PortFirewall[8], PortFirewall[9],PortFirewall[10], PortFirewall[11], PortFirewall[12], PortFirewall[13], PortFirewall[14]	);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, PortFirewallListe);
	g_free (PortFirewallListe);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Port_Udp_Info_Equipement (gpointer * pointer)
{
	#define PORT_UDP_RECUP 10
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;	
	gchar    *Nouveau_Texte = NULL,*PortUdpListe = NULL;
	gint      i,j, PortUdp[PORT_UDP_RECUP];
	
	ERROR_if (pointer == NULL);

	bzero (PortUdp, sizeof (gint) * PORT_UDP_RECUP);
	i = 0;
	j = 0;
	while ((i < NB_PORT_UDP) && (i < PORT_UDP_RECUP)) {
		if (Equipement->Liste_Etat_Udp[i]==UNKOWN_UDP){
			PortUdp[j] = Liste_Port_UDP[i].Num_Port_UDP;
			j++;
		}
		i++;
	}
	PortUdpListe = g_strdup_printf ("[%d-%d-%d-%d-%d-%d-%d-%d-%d-%d...]",PortUdp[0], PortUdp[1], PortUdp[2], PortUdp[3], PortUdp[4], PortUdp[5], PortUdp[6], PortUdp[7], PortUdp[8], PortUdp[9]);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, PortUdpListe);
	g_free (PortUdpListe);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Dernier_Changement_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;
	gchar     Date[30];

	ERROR_if (pointer == NULL);
	ctime_r (&Equipement->Derniere_Modification_Etat_Equipement, Date);
	Date[strlen (Date) - 1] = '\0';
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Date);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]   [%s][%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Date) + 1), Nouveau_Texte, Objet->Texte_Defaut, Date);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Temps_Scan_Complet_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Complet);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Complet_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Temps_Scan_Port_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Port);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Port_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Temps_Scan_Port_Udp_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Port_Udp);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Port_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Temps_Scan_Signature_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Signature);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Signature_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Temps_Scan_Service_FTP_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Service_Ftp);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Service_FTP_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Temps_Scan_Service_HTTP_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Service_Http);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Service_HTTP_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Temps_Scan_Service_IMAP_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Service_Imap);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Service_IMAP_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Temps_Scan_Service_TELNET_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Service_Telnet);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Service_TELNET_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Temps_Scan_Snmp_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Temps_Scan_Snmp);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion_Texte_Temps_Scan_Snmp_Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_HostName_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *HostName = NULL;

	ERROR_if (pointer == NULL);
	HostName = Equipement->Smb.HostName;
	if (HostName == NULL)
		HostName = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, HostName);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (HostName) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Alias_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Alias = NULL;

	ERROR_if (pointer == NULL);
	Alias = Equipement->Alias;

	if (Alias == NULL)
		Alias = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Alias);
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion Alias Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Alias) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Ping_Time_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Ping_Time = NULL;

	ERROR_if (pointer == NULL);
	Ping_Time = Equipement->Ping_Time;
	if (Ping_Time == NULL)
		Ping_Time = "--";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Ping_Time);
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion Ping_Time Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Ping_Time) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Dns_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Nom_DNS_Complet = NULL;

	ERROR_if (pointer == NULL);

	Nom_DNS_Complet = Equipement->Nom_DNS_Complet;
	if (Nom_DNS_Complet == NULL)
		Nom_DNS_Complet = "none";

	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Nom_DNS_Complet);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Nom_DNS_Complet) + 1), Nouveau_Texte);

	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Domaine_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Domaine = NULL;

	ERROR_if (pointer == NULL);
	Domaine = Equipement->Smb.DomainName;
	if (Domaine == NULL)
		Domaine = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Domaine);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Domaine) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Utilisateur_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Utilisateur = NULL;

	ERROR_if (pointer == NULL);
	Utilisateur = Equipement->Smb.Utilisateur;
	if (Utilisateur == NULL)
		Utilisateur = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Utilisateur);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Utilisateur) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}



gchar    *Gestion_Texte_Type_Parent (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Type = NULL;

	ERROR_if (pointer == NULL);
	switch (Objet_Equipement_Selectionner->ID_Modele_Objet) {
	    case LISTE_SERVEUR:
		    Type = "Server";
		    break;
	    case LISTE_SWITCH:
		    Type = "Switch";
		    break;
	    case LISTE_MULTIMEDIA:
		    Type = "Multimedia";
		    break;
	    case LISTE_CONSOLE:
		    Type = "Console";
		    break;
	    case LISTE_WIFI:
		    Type = "Wifi";
		    break;
	    case LISTE_PDA:
		    Type = "Pda";
		    break;
	    case LISTE_IMPRIMANTE:
		    Type = "Printer";
		    break;
	    case LISTE_ROUTEUR:
		    Type = "Router";
		    break;
	    case LISTE_STATION:
		    Type = "Workstation";
		    break;
	    case LISTE_DISQUE:
		    Type = "Disk";
		    break;
	    case LISTE_SECURITY_CAMERA:
		    Type = "Security Camera";
		    break;
	    case LISTE_UPS:
		    Type = "UPS";
		    break;
	    case LISTE_TELEPHONIE:
		    Type = "Ip phone";
		    break;
	    case LISTE_ROUTEUR_SWITCH:
		    Type = "Router-Switch";
		    break;
	    case LISTE_ROUTEUR_ADSL:
		    Type = "Router ADSL";
		    break;
	    case LISTE_MODEM:
		    Type = "Modem";
		    break;
	    case LISTE_FIREWALL:
		    Type = "Firewall";
		    break;
	    case LISTE_VPN:
		    Type = "Vpn";
		    break;
	    case LISTE_CAMERA:
		    Type = "Camera";
		    break;
	    case LISTE_CELLULAR_PHONE:
		    Type = "Cellular Phone";
		    break;
	    case LISTE_MP3_PLAYER:
		    Type = "MP3 Player";
		    break;
	    case LISTE_TABLET:
		    Type = "Tablet";
		    break;
	    case LISTE_CAMCORDER:
		    Type = "Camcorder";
		    break;
	    case LISTE_POWERLINE:
		    Type = "PowerLine";
		    break;
	    case LISTE_FAX:
		    Type = "FAX";
		    break;

	    case LISTE_INCONNU:
		    Type = "Unknown";
		    break;
	    case LISTE_FIREWALLED:
		    Type = "Firewalled";
		    break;
	    case LISTE_MODELE_DOMAINE:
		    Type = "Domain";
		    break;
	    default:
		    Type = "unknow";
	}
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Type);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Gestion_Texte_Type_Parent  Taille [%d]   [%s]", (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Type) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}



gchar    *Gestion_Texte_Parent_Nb_Fils (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Objet_Equipement_Selectionner->Nb_Enfant);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Gestion_Texte_Parent_Nb_Fils  Taille [%s]", Nouveau_Texte);
	return Nouveau_Texte;
}
