/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dirent.h>
#include <malloc.h>
#include <signal.h>
#include "Quit.h"
#include "Module_Samba.h"
#include "Declaration_Constante.h"
#include "Interface/Root_Interface.h"
#include "Interface/Settings_Interface.h"
#include "Interface/Arret_Interface.h"
#include "Applet.h"
#include "Sound.h"
#include "Debug.h"
#include "Gconf.h"
#include "main.h"
#include "Update.h"
#include "Sound.h"
#include "Smtp.h"
#include "Contribution.h"
#include "Log.h"
#include "BackTrace.h"
#include "Com/Commun.h"
#include "Semaphore.h"
#include "Mem.h"


#ifdef __LOG_ENABLE
extern struct Struct_Categorie Liste_Categorie[];
#endif

#ifdef __LOG_ENABLE

void Ecriture_Fichier_Sans_Retour_Chariot(int fd,gchar *Log){
	gint Taille_Chaine;
	
	Taille_Chaine = strlen(Log);
	if (Taille_Chaine!=write(fd,Log,Taille_Chaine)){
		printf("ERROR : Create log  (write)\n");
		exit (-1);
	}
}

void Ecriture_Fichier(int fd,gchar *Log){
gint Taille_Chaine;
	
	Taille_Chaine = strlen(Log);
	if (Taille_Chaine!=write(fd,Log,Taille_Chaine)){
		printf("ERROR : Create log  (write)\n");
		exit (-1);
	}
	if (write(fd,"\n",1)!=1){
		printf("ERROR : Create log  (write)\n");
		exit (-1);
	}
}


void Enregistrement_Log(){
	struct Struct_Liste_Equipement *Equipement = NULL;
	DIR      *dir;
	gchar    *Log,*Chemin;
	gint      Nb_Equipement, i,j, Nb_Log,Taille_Chaine;
	
	
	Chemin = g_strdup_printf ("%s/.autoscan-network/Log", Info_User->pw_dir);
	dir = opendir (Chemin);
	if (dir == NULL) {
	
		if (mkdir (Chemin, 0766) != 0) {
			printf("ERROR : Save log  (mkdir)\n");
			exit (-1);
		}
		dir = opendir (Chemin);
		if (dir == NULL) {
			printf("ERROR : Save log  (opendir)\n");
			exit (-1);
		}
	}
	closedir (dir);
	g_free (Chemin);
	
	Chemin = g_strdup_printf ("%s/.autoscan-network/Log/autoscan-network", Info_User->pw_dir);
	fd_Fichier_Log = open(Chemin, O_WRONLY | O_CREAT | O_TRUNC, 0644);
	if (fd_Fichier_Log < 0){
		printf("ERROR : Create log  (open)\n");
		exit (-1);
	}
	g_free (Chemin);
	
	Ecriture_Fichier(fd_Fichier_Log,"************** MAIN **************");
	Nb_Log = g_list_length (GList_Log_Main);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Main, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	
	
	Ecriture_Fichier(fd_Fichier_Log,"************** Thread Test Version **************");
	Nb_Log = g_list_length (GList_Log_Thread_Test_Version);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Test_Version, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}

	
#ifdef  __SOUND_ENABLE
	Ecriture_Fichier(fd_Fichier_Log,"************** Thread Sound **************");
	Nb_Log = g_list_length (GList_Log_Thread_Sound);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Sound, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
#endif	

	
	Ecriture_Fichier(fd_Fichier_Log,"************** Thread Envoie Email **************");
	Nb_Log = g_list_length (GList_Log_Thread_Envoie_Email);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Envoie_Email, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	
	
	Ecriture_Fichier(fd_Fichier_Log,"************** Thread Robot **************");
	Nb_Log = g_list_length (GList_Log_Thread_Contribution);
	for (j=0;j<Nb_Log;j++){
		Log = g_list_nth_data (GList_Log_Thread_Contribution, j);
		Ecriture_Fichier(fd_Fichier_Log,Log);
	}
	close(fd_Fichier_Log);
	fd_Fichier_Log = 0;
}
#endif	



void Enregistre_Position_Fenetre (void)
{
	gint      hauteur, largeur, x, y;

	Enregistrement_Gconf_Entier (INT_ROOT_POSITION_X, 30);
	Enregistrement_Gconf_Entier (INT_ROOT_POSITION_Y, 30);
	gtk_window_get_size ((GtkWindow *) window_root, &largeur, &hauteur);
	Enregistrement_Gconf_Entier (INT_ROOT_SIZE_X, largeur);
	Enregistrement_Gconf_Entier (INT_ROOT_SIZE_Y, hauteur);
	gtk_window_get_size ((GtkWindow *) dialog_Settings, &largeur, &hauteur);
	Enregistrement_Gconf_Entier (INT_SETTINGS_SIZE_X, largeur);
	Enregistrement_Gconf_Entier (INT_SETTINGS_SIZE_Y, hauteur);
	Enregistrement_Gconf_Entier (INT_V_PANED_POSITION, gtk_paned_get_position (GTK_PANED (vpaned_root)));
	Enregistrement_Gconf_Entier (INT_H_PANED_POSITION, gtk_paned_get_position (GTK_PANED (hpaned_root)));
}


void Control_C (int sig)
{
	printf ("(Control_C)\n");
	Arret_Utilisateur ();
}

void Arret_Immediat(){
	printf("Arret_Immediat : FAILED\n");
#ifdef __LOG_ENABLE
	if (fd_Fichier_Log!=0)
		close(fd_Fichier_Log);
#endif
	exit(-1);
}


void Pause_Thread( int signum, siginfo_t *info, void *secret ){

	PROTECT_CODE(Semaphore_Etat_Thread);
	
	struct struct_Cle_Privee *pCle = NULL;
	GList    *GList_Log = NULL;
		
	if ((pCle = pthread_getspecific (Cle_privee_thread)) == NULL)
		pCle = Donnee_Cle_Main;
	printf("Thread [%s]\n",Liste_Categorie[pCle->Categorie].Info);

	GList_Log = Recupere_Glist_Categorie(pCle);
	display_backtrace(GList_Log,NULL,0);
	Nb_Thead--; 
	DEPROTECT_CODE(Semaphore_Etat_Thread); 
	while (1)	pause(); 
}




void segfault_handler (int sig)
{
	gchar     Info[TAILLE_INFO_ERREUR_CRITIQUE];
	struct struct_Cle_Privee *pCle = NULL;
	GList    *GList_Log = NULL;
	gchar    *Info_Log = NULL;
	GtkWidget *Win_Demande_User;
	gchar *Message_Erreur;
	gint Nb_Log,Log,Nb_Caract_Info;
	

	fd_Fichier_Log = 0;
	signal (SIGSEGV, Arret_Immediat);
	/*__malloc_hook = NULL;
	__realloc_hook = NULL;
	__free_hook = NULL;	*/


	print_trace();
	display_backtrace(NULL,NULL,0);
	

	if ((pCle = pthread_getspecific (Cle_privee_thread)) == NULL)
		pCle = Donnee_Cle_Main;
	printf ("Segfault : Invalid memory reference (%s)\n", Liste_Categorie[pCle->Categorie].Info);


	GList_Log = Recupere_Glist_Categorie(pCle);
	GList_Log = g_list_append (GList_Log, "---------- Segfault ----------");

	display_backtrace (GList_Log,NULL,0);
#ifdef __LOG_ENABLE
	Enregistrement_Log();
#endif	

	gtk_widget_hide_all (window_root);
	Message_Erreur = g_strdup_printf ("Segfault : Invalid memory reference (%s)", Liste_Categorie[pCle->Categorie].Info);
	Win_Demande_User = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, Message_Erreur);
	gtk_dialog_run (GTK_DIALOG (Win_Demande_User));
	gtk_widget_hide(Win_Demande_User);
	g_free(Message_Erreur);

	sprintf (Info, "Segfault : Invalid memory reference (%s)\n\nFichier : (%s)\nFonction : (%s)   \n\nAction_Utilisateur\n (%s) (%s)\n", Liste_Categorie[pCle->Categorie].Info,File_Debug,Fonction_Debug,File_Action_User,Fonction_Action_User);
	Nb_Log = g_list_length (GList_Log);
	Log = Nb_Log;
	Nb_Caract_Info = strlen(Info) + 1;
	while ((Log > 1) && (Log + 100 != Nb_Log) && (Nb_Caract_Info < TAILLE_INFO_ERREUR_CRITIQUE)) {
		Info_Log = g_list_nth_data (GList_Log, Log - 1);
		if ((strlen (Info_Log) + Nb_Caract_Info) > TAILLE_INFO_ERREUR_CRITIQUE)
			break;
		strcat (Info, Info_Log);
		strcat (Info, "\n");
		Nb_Caract_Info = Nb_Caract_Info + strlen (Info_Log) + 2;
		Log--;
	}
	contribution_Erreur (Info);

	Exit();
}


void Initialisation_signaux (void)
{
	struct sigaction    sa;
 	sigset_t            sigmsk;

 
	sigfillset( &sigmsk );
    sigdelset( &sigmsk, SIGUSR1 );
	sigdelset( &sigmsk, SIGUSR2 );
    sigdelset( &sigmsk, SIGHUP );
    sigdelset( &sigmsk, SIGWINCH );
    sigdelset( &sigmsk, SIGINT );
    sigdelset( &sigmsk, SIGSEGV );
    sigdelset( &sigmsk, SIGILL );
    sigdelset( &sigmsk, SIGFPE );
    pthread_sigmask( SIG_SETMASK, &sigmsk, NULL );

 
    sa.sa_sigaction = Pause_Thread;
    sigemptyset( &sa.sa_mask );
    sa.sa_flags = SA_RESTART;
    sigaction( SIGUSR1, &sa, NULL );
	
	signal (SIGINT, Control_C);
	signal (SIGTERM, Arret_Utilisateur);
	signal (SIGHUP, Arret_Utilisateur);
	signal (SIGSEGV, segfault_handler);
}


void Arret_Utilisateur (void)
{
	gtk_widget_hide_all (window_root);
	Enregistre_Position_Fenetre ();
	Arret_Demande();
}

void Arret_Erreur (void)	
{
	Arret_Demande();
}


void Exit(void){
	struct struct_Cle_Privee *pCle = NULL;
	GList    *GList_Log = NULL;
	
#ifdef __LOG_ENABLE

	pCle = Donnee_Cle_Main;
	GList_Log = Recupere_Glist_Categorie(pCle);
#endif

#ifdef __BACKTRACE_ENABLE
	display_backtrace (GList_Log,NULL,0);
#endif
#ifdef __SAMBA_ENABLE
	Demonte_Tout_Partage ();
#endif
#ifdef __LOG_ENABLE
	Enregistrement_Log();
#endif
	Arreter_Tous_Les_Agents ();
	printf ("Stopping %s (http://autoscan-network.com)\n", VERSION_AUTOSCAN);
	gtk_main_quit ();
	exit(EXIT_SUCCESS);	
}



void Arret_Demande(void){
	if(!pthread_equal( pthread_self(), mainThreadId )){
		pthread_kill(mainThreadId,SIGINT);
		printf("Stopping ...\n");
		sleep(1);  
	
	
	
		printf("__1\n");
		sleep(1); 
		printf("__2\n");
		sleep(1); 
		printf("__3\n");
		sleep(1); 
		Exit();
	}

	fd_Fichier_Log = 0;
	signal (SIGSEGV, Arret_Immediat);

	printf("******** Stopping Thread  *************\n");
	envoie_Signal_All_Thread(SIGUSR1);
	while (Nb_Thead!=0)
		sleep(1);
	printf("***************************************\n");
	gtk_widget_hide_all (window_root);
#ifdef __EGGTRAYICON_ENABLE
	destruction_applet_icone ();
#endif	
	Exit();
}


#ifdef __CKECK_MALLOC_ENABLE

void Arret_Demande_Mem_Failed (struct struct_Cle_Privee *pCle,gpointer * Message,gchar *Fonction,void *pointeur, void *appel)
{
	/*struct Struct_Liste_Equipement* Equipement = NULL;
	GList    *GList_Log = NULL;
	gchar	*log;
	
	debug_memoire_disable();	

	fd_Fichier_Log = 0;
	signal (SIGSEGV, Arret_Immediat);

	display_backtrace(NULL,NULL,0);

	if (pCle->Categorie==CATEG_THREAD_SCAN)
		Equipement = pCle->Pointeur_Data;
	printf ("Memory corruption (%s)\n", Liste_Categorie[pCle->Categorie].Info);
	GList_Log = Recupere_Glist_Categorie(pCle);
	GList_Log = g_list_append (GList_Log, "---------- Memory corruption ----------");
	log = g_strdup_printf(Message,Fonction,pointeur,appel);
	GList_Log = g_list_append (GList_Log, log);

	Vidage_Memoire();

	display_backtrace (GList_Log,NULL,0);

	pthread_kill(mainThreadId,SIGINT);
	printf("Stopping ()...\n");
	sleep(1);  



	printf("__1\n");
	sleep(1); 
	printf("__2\n");
	sleep(1); 
	printf("__3\n");
	sleep(1); 
	Exit();*/
}
#endif
