/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2007 Thierry Lagarde <tlagarde@users.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Thread.h"
#include "Debug.h"
#include "Semaphore.h"
#include <signal.h>

void demmarrage_Thread (void *thread, gpointer * pointeur)
{
	PROTECT_CODE (Semaphore_Thread);
	struct Struct_Liste_Thread *Thread = NULL;

	Thread = (struct Struct_Liste_Thread *) malloc (sizeof (struct Struct_Liste_Thread));
	if (pthread_create (&Thread->pThread, NULL, (void *) thread, pointeur) != 0) {
		debug_printf (D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Demmarage_Thread (%d): Impossible de démarrer le thread%d", getpid ());
	}
	pthread_detach (Thread->pThread);
	Nb_Thead++;
	Id_Thread++;	
	Thread->Id_Thread = Id_Thread;
	GList_Liste_Thread = g_list_append (GList_Liste_Thread, Thread);
	DEPROTECT_CODE (Semaphore_Thread);
}


void Stop_Thread (void *retval)
{
	PROTECT_CODE (Semaphore_Thread);

	struct Struct_Liste_Thread *Thread = NULL, *Thread_Trouver;
	pthread_t Thread_Id;
	gint      i, Nb_Objet_Liste;

	Thread_Id = pthread_self ();
	Thread_Trouver = NULL;


	Nb_Objet_Liste = g_list_length (GList_Liste_Thread);
	for (i = 0; i < Nb_Objet_Liste; i++) {
	
		Thread = g_list_nth_data (GList_Liste_Thread, i);
		if (pthread_equal (Thread->pThread, Thread_Id)) {
			Thread_Trouver = Thread;
		
			break;
		}
	}
	if (Thread_Trouver != NULL)
		GList_Liste_Thread = g_list_remove (GList_Liste_Thread, Thread_Trouver);
	else
		printf ("[WARNING] Thread Non référencé\n");
	Nb_Thead--;
	DEPROTECT_CODE (Semaphore_Thread);
	pthread_exit (retval);
}


void envoie_Signal_All_Thread (int signum)
{
	PROTECT_CODE (Semaphore_Thread);

	struct Struct_Liste_Thread *Thread = NULL;
	pthread_t Thread_Id;
	gint      i, Nb_Objet_Liste;

	Nb_Objet_Liste = g_list_length (GList_Liste_Thread);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Thread = g_list_nth_data (GList_Liste_Thread, i);
		pthread_kill (Thread->pThread, signum);
	}
	DEPROTECT_CODE (Semaphore_Thread);
}
